﻿Public Class Form2

    Public Shadows Sub Load(ByVal Maps As List(Of Form1.Map))

        LstSearch = New List(Of String)
        OldList = New List(Of String)

        LstSearch2 = New List(Of String)
        OldList2 = New List(Of String)

        For Each Map As Form1.Map In Maps
            ListBox1.Items.Add(IO.Path.GetFileNameWithoutExtension(Map.Path))
            OldList.Add(IO.Path.GetFileNameWithoutExtension(Map.Path))
        Next

        Label3.Text = "Maps: " & OldList.Count
        Label3.Location = New Point(ListBox1.Location.X - Label3.Width + ListBox1.Width, Label3.Location.Y)

        MyBase.Show()
    End Sub

    Private Sub LinkLabel1_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        MsgBox("Ganz einfach: Für jede Map wird ein eigener Ordner mit dessen Bildern erstellt.")
    End Sub

    ' Listbox1
    Dim LstSearch As List(Of String)
    Dim OldList As List(Of String)

    ' Listbox2
    Dim LstSearch2 As List(Of String)
    Dim OldList2 As List(Of String)

    Private Sub TextBox2_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox2.KeyDown
        If e.KeyCode = Keys.Escape Then
            TextBox2.Clear()
        End If
    End Sub

    Private Sub TextBox2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox2.TextChanged
        LstSearch.Clear()
        For Each t In OldList
            If Not t.ToString.ToLower.Contains(TextBox2.Text.ToLower) Then
                Continue For
            End If
            LstSearch.Add(t)
        Next
        ListBox1.Items.Clear()
        For Each t In LstSearch
            ListBox1.Items.Add(t)
        Next
        ListBox1.Refresh()
    End Sub

    Private Sub TextBox3_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox3.KeyDown
        If e.KeyCode = Keys.Escape Then
            TextBox3.Clear()
        End If
    End Sub

    Private Sub TextBox3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox3.TextChanged
        LstSearch2.Clear()
        For Each t In OldList2
            If Not t.ToString.ToLower.Contains(TextBox3.Text.ToLower) Then
                Continue For
            End If
            LstSearch2.Add(t)
        Next
        ListBox2.Items.Clear()
        For Each t In LstSearch2
            ListBox2.Items.Add(t)
        Next
        ListBox2.Refresh()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        If ListBox1.SelectedIndex = -1 = False Then
            Dim AlreadyExists As Boolean = False
            For i = 0 To ListBox2.Items.Count - 1
                If ListBox2.Items(i) = ListBox1.Items(ListBox1.SelectedIndex) Then
                    AlreadyExists = True
                End If
            Next
            If AlreadyExists = False Then
                ListBox2.Items.Add(ListBox1.Items(ListBox1.SelectedIndex))
                OldList2.Add(ListBox1.Items(ListBox1.SelectedIndex))
            End If
        End If

        Label4.Text = "Maps: " & OldList2.Count
        Label4.Location = New Point(ListBox2.Location.X - Label4.Width + ListBox2.Width, Label4.Location.Y)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If ListBox2.SelectedIndex = -1 = False Then
            OldList2.Remove(ListBox2.Items(ListBox2.SelectedIndex))
            ListBox2.Items.RemoveAt(ListBox2.SelectedIndex)
        End If

        Label4.Text = "Maps: " & OldList2.Count
        Label4.Location = New Point(ListBox2.Location.X - Label4.Width + ListBox2.Width, Label4.Location.Y)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ListBox2.Items.Clear()
        OldList2.Clear()
        For i = 0 To ListBox1.Items.Count - 1
            ListBox2.Items.Add(ListBox1.Items(i))
            OldList2.Add(ListBox1.Items(i))
        Next

        Label4.Text = "Maps: " & OldList2.Count
        Label4.Location = New Point(ListBox2.Location.X - Label4.Width + ListBox2.Width, Label4.Location.Y)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ListBox2.Items.Clear()
        OldList2.Clear()

        Label4.Text = "Maps: " & OldList2.Count
        Label4.Location = New Point(ListBox2.Location.X - Label4.Width + ListBox2.Width, Label4.Location.Y)
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        TextBox1.Enabled = CheckBox1.Checked
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        If ListBox2.Items.Count < 1 Then
            MsgBox("Du musst mindestens eine Map zum extrahieren auswählen!")
            Return
        End If

        Dim MapList As New List(Of String)
        For i = 0 To ListBox2.Items.Count - 1
            Dim Added As Boolean = False
            For Each File In IO.Directory.GetFiles(Form1.Maps)
                If IO.Path.GetFileNameWithoutExtension(File) = ListBox2.Items(i) Then
                    MapList.Add(Form1.Maps & "\" & ListBox2.Items(i) & ".map")
                    Added = True
                End If
                If Added = False Then
                    For Each File1 In IO.Directory.GetFiles(Form1.Downloadedmaps)
                        If IO.Path.GetFileNameWithoutExtension(File1) = ListBox2.Items(i) Then
                            MapList.Add(Form1.Downloadedmaps & "\" & ListBox2.Items(i) & ".map")
                            Added = True
                        End If
                    Next
                End If
            Next

        Next

        Dim TargetPath As String = ""
        If CheckBox1.Checked Then
            TargetPath = TextBox1.Text
        Else
            TargetPath = Environment.CurrentDirectory() & "\map-img\"
        End If
        Form3.Load(TargetPath, CheckBox2.Checked, MapList)
    End Sub
End Class