﻿Public Class Form3

    Dim TargetPath As String
    Dim MapList As List(Of String)
    Dim EachMapFolder As Boolean

    Public Shadows Sub Load(ByVal _TargetPath As String, ByVal _EachMapFolder As Boolean, ByVal Maps As List(Of String))

        Button2.Visible = False
        TargetPath = _TargetPath

        MapList = Maps
        EachMapFolder = _EachMapFolder

        MyBase.ShowDialog()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Button1.Text = "Schliessen" Then
            Me.Close()
        Else
            If MsgBox("Bist du sicher, dass du den aktuellen Prozess beenden willst?", vbYesNo) = MsgBoxResult.Yes Then
                Me.Close()
            Else
                Return
            End If
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Process.Start(TargetPath)
    End Sub

    Private Sub Form3_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        lStatus.Text = "Extrahiere Map 0 von " & MapList.Count
        ProgressBar1.Maximum = MapList.Count

        Dim ExtractThread As New Threading.Thread(AddressOf Extract)
        ExtractThread.Start()
    End Sub

    Sub Extract()
        For Each Map In MapList
            Try
                Invoke(Sub()
                           ProgressBar1.Increment(1)
                           lStatus.Text = String.Format("Extrahiere Map {0} von {1}... ({2}%)", ProgressBar1.Value, ProgressBar1.Maximum, Math.Round(ProgressBar1.Value / ProgressBar1.Maximum * 100, 1))
                       End Sub)



                Dim ExtractorPath As String = TargetPath
                If EachMapFolder = True Then
                    ExtractorPath = TargetPath & "\" & IO.Path.GetFileNameWithoutExtension(Map)
                End If
                Dim MapExtractFile As String = ExtractorPath & "\map_extract.exe"
                If IO.Directory.Exists(ExtractorPath) = False Then
                    IO.Directory.CreateDirectory(ExtractorPath)
                End If
                IO.File.WriteAllBytes(MapExtractFile, My.Resources.map_extract)

                Dim MapExtract As New Process
                MapExtract.StartInfo.FileName = MapExtractFile
                MapExtract.StartInfo.WorkingDirectory = ExtractorPath & "\"
                MapExtract.StartInfo.Arguments = """" & Map & """"
                MapExtract.StartInfo.WindowStyle = ProcessWindowStyle.Hidden
                MapExtract.Start()
                MapExtract.WaitForExit()

                Threading.Thread.Sleep(20)
                IO.File.Delete(MapExtractFile)
            Catch
                ' just jump :3
            End Try
        Next

        Invoke(Sub()
                   Button2.Visible = True
                   Button1.Text = "Schliessen"
                   Button3.Visible = False
               End Sub)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        For Each p In Process.GetProcesses
            If p.ProcessName.Contains("map_extract.exe") Then
                p.Kill()
                Exit For
            End If
        Next
    End Sub
End Class